/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.xelfi.quoridor.desktop.sample;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.GenericType;
import com.sun.jersey.api.client.WebResource;
import cz.xelfi.quoridor.webidor.Game;
import cz.xelfi.quoridor.webidor.GameId;
import java.util.List;
import javax.ws.rs.core.MediaType;
import org.openide.util.Lookup;

/** Class that connects to the server and answers queries.
 *
 * @author Jaroslav Tulach
 */
abstract class Quoridor {

    public static Quoridor getDefault() {
        Quoridor q = Lookup.getDefault().lookup(Quoridor.class);
        return q == null ? new Impl() : q;
    }

    public abstract List<GameId> listGames();
    public abstract Game getGame(String id);

    private static class Impl extends Quoridor {
        private final WebResource wr;

        public Impl() {
            Client c = new Client();
            wr = c.resource("http://quoridor.xelfi.cz/api/");
        }

        @Override
        public List<GameId> listGames() {
            GenericType<List<GameId>> gType = new GenericType<List<GameId>>() {};
            List<GameId> ids = wr.path("games").accept(MediaType.TEXT_XML).get(gType);
            return ids;
        }


        @Override
        public Game getGame(String id) {
            Game g = wr.path("games").path(id).accept(MediaType.TEXT_XML).get(Game.class);
            return g;
        }

    }
}
